package at.gv.brz.bjujq.erv.samples.anschriftcode;

import at.gv.brz.bjujq.erv.samples.common.MockErvAnschriftcodePortBuilder;
import at.gv.brz.bjujq.erv.samples.common.SchemaUtil;
import at.gv.justiz.erv.ervanschriftcodenachrichtextern.v3_0.AnschriftcodedatenTyp;
import at.gv.justiz.erv.ervanschriftcodenachrichtextern.v3_0.StatusfehlerdatenTyp;
import at.gv.justiz.erv.ervanschriftcodeserviceextern.v3_0.ERVAnschriftcodePortType;
import at.gv.justiz.erv.ervanschriftcodeserviceextern.v3_0.ERVAnschriftcodeServiceException_Exception;
import at.gv.justiz.erv.ervanschriftcodeserviceextern.v3_0.StatusSetzenRequest;
import at.gv.justiz.erv.ervanschriftcodeserviceextern.v3_0.StatusSetzenResponse;
import at.gv.justiz.erv.ervwertebereichextern.v3_0.AnschriftcodeStatus;
import at.gv.justiz.erv.ervwertebereichextern.v3_0.Service;

public class StatusSetzen {


    public static void main(String[] args) throws ERVAnschriftcodeServiceException_Exception {
        ERVAnschriftcodePortType ervAnschriftcodePortType = new MockErvAnschriftcodePortBuilder()
                                .withStatusSetzen()
                                .build();

        StatusSetzenRequest request = SchemaUtil.OF_AN_SERVICE.createStatusSetzenRequest();
        AnschriftcodedatenTyp anschriftcodedatenTyp = SchemaUtil.OF_AN_NR.createAnschriftcodedatenTyp();
        anschriftcodedatenTyp.setAnschriftcode("R000001");
        anschriftcodedatenTyp.setService(SchemaUtil.OF_TYP.createServiceTyp());
        anschriftcodedatenTyp.getService().setServiceProvider("TEST");
        anschriftcodedatenTyp.getService().setServiceArt(Service.UEBERMITTLUNGSSTELLE);
        anschriftcodedatenTyp.setStatus(AnschriftcodeStatus.E);
        anschriftcodedatenTyp.setZeitpunkt(SchemaUtil.createCurrentDateTime());
        request.getAnschriftcodedaten().add(anschriftcodedatenTyp);

        StatusSetzenResponse response = ervAnschriftcodePortType.statusSetzen(request);

        // Fehlercodes siehe ERV-Publikation
        if (response.getFehler() != null) {

        } else {
            for (StatusfehlerdatenTyp statusfehlerdatenTyp : response.getStatusfehler()) {
                // Fehlerbehandlung pro Anschriftcode
            }
        }

    }
}
